// dist/drivers/cache_mdEditor.js
import {
  combineLatest,
  computed,
  inputComputeInServer,
  model,
  progress,
  state,
  writeModel,
} from "tarat/core";

// models/indexes.json
var indexes_default = {
  markdown: "markdown",
};

// dist/drivers/cache_mdEditor.js
function mdEditor(q = {}) {
  const currentId = state(q.id);
  const inputMD = state("");
  const inputTitle = state("");
  const currentPost = model(indexes_default.markdown, () => {
    const cid = currentId();
    if (cid) {
      return {
        where: {
          id: cid,
        },
      };
    }
  });
  const currentProgress = progress(currentPost);
  const markdownTitle = computed(() => {
    var _a;
    return (_a = currentPost()[0]) == null ? void 0 : _a.title;
  });
  const postedMD = computed(() => {
    var _a;
    return (_a = currentPost()[0]) == null ? void 0 : _a.content;
  });
  const displayMD = combineLatest([inputMD, postedMD]);
  const displayTitle = combineLatest([inputTitle, markdownTitle]);
  const writeCurrentMD = writeModel(currentPost, () => ({
    title: inputTitle() || displayTitle() || "",
    content: inputMD() || displayMD() || "",
  }));
  const save = inputComputeInServer(() => {});
  const saveProgess = progress(save);
  return {
    currentId,
    currentProgress,
    displayMD,
    postedMD,
    inputMD,
    inputTitle,
    displayTitle,
    save,
    saveProgess,
  };
}
var autoParser1674486654837_0 = {
  mdEditor: {
    names: [
      [0, "currentId"],
      [1, "inputMD"],
      [2, "inputTitle"],
      [3, "currentPost"],
      [4, "markdownTitle"],
      [5, "postedMD"],
      [6, "writeCurrentMD"],
      [7, "save"],
    ],
    deps: [
      ["h", 3, [0]],
      ["h", 4, [3]],
      ["h", 5, [3]],
      ["ic", 6, [2, 1], [3]],
      ["ic", 7, [0], [6]],
    ],
  },
};
Object.assign(mdEditor, {
  __deps__: autoParser1674486654837_0.mdEditor.deps,
  __names__: autoParser1674486654837_0.mdEditor.names,
  __name__: "mdEditor",
  __namespace__: "tarat-markdown-editor",
});
export { mdEditor as default };
/*! can not invoked in current runtime */

/**. auto generated by tarat */
// location at:/Users/yunge/Documents/tarat/packages/example/markdown-editor/dist/client/drivers/esm/mdEditor.js
const autoParser1674486656889_3 = {
  mdEditor: {
    names: [
      [0, "currentId"],
      [1, "inputMD"],
      [2, "inputTitle"],
      [3, "currentPost"],
      [4, "markdownTitle"],
      [5, "postedMD"],
      [6, "writeCurrentMD"],
      [7, "save"],
    ],
    deps: [
      ["h", 3, [0]],
      ["h", 4, [3]],
      ["h", 5, [3]],
      ["ic", 6, [2, 1], [3]],
      ["ic", 7, [0], [6]],
    ],
  },
};
Object.assign(mdEditor, {
  __deps__: autoParser1674486656889_3.mdEditor.deps,
  __names__: autoParser1674486656889_3.mdEditor.names,
  __name__: "mdEditor",
  __namespace__: "tarat-markdown-editor",
});
/** auto generated by tarat .*/
