var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if ((from && typeof from === "object") || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, {
          get: () => from[key],
          enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable,
        });
  }
  return to;
};
var __toCommonJS = (mod) =>
  __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// dist/drivers/mdEditor.js
var mdEditor_exports = {};
__export(mdEditor_exports, {
  default: () => mdEditor,
});
module.exports = __toCommonJS(mdEditor_exports);
var import_core = require("tarat/core");

// models/indexes.json
var indexes_default = {
  markdown: "markdown",
};

// dist/drivers/mdEditor.js
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) =>
      x.done
        ? resolve(x.value)
        : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
function mdEditor(q = {}) {
  const currentId = (0, import_core.state)(q.id);
  const inputMD = (0, import_core.state)("");
  const inputTitle = (0, import_core.state)("");
  const currentPost = (0, import_core.model)(indexes_default.markdown, () => {
    const cid = currentId();
    if (cid) {
      return {
        where: {
          id: cid,
        },
      };
    }
  });
  const currentProgress = (0, import_core.progress)(currentPost);
  const markdownTitle = (0, import_core.computed)(() => {
    var _a;
    return (_a = currentPost()[0]) == null ? void 0 : _a.title;
  });
  const postedMD = (0, import_core.computed)(() => {
    var _a;
    return (_a = currentPost()[0]) == null ? void 0 : _a.content;
  });
  const displayMD = (0, import_core.combineLatest)([inputMD, postedMD]);
  const displayTitle = (0, import_core.combineLatest)([
    inputTitle,
    markdownTitle,
  ]);
  const writeCurrentMD = (0, import_core.writeModel)(currentPost, () => ({
    title: inputTitle() || displayTitle() || "",
    content: inputMD() || displayMD() || "",
  }));
  const save = (0, import_core.inputComputeInServer)(() =>
    __async(this, null, function* () {
      const cid = currentId();
      if (cid) {
        writeCurrentMD.update(cid);
      }
    })
  );
  const saveProgess = (0, import_core.progress)(save);
  return {
    currentId,
    currentProgress,
    displayMD,
    postedMD,
    inputMD,
    inputTitle,
    displayTitle,
    save,
    saveProgess,
  };
}
var autoParser1674486654837_0 = {
  mdEditor: {
    names: [
      [0, "currentId"],
      [1, "inputMD"],
      [2, "inputTitle"],
      [3, "currentPost"],
      [4, "markdownTitle"],
      [5, "postedMD"],
      [6, "writeCurrentMD"],
      [7, "save"],
    ],
    deps: [
      ["h", 3, [0]],
      ["h", 4, [3]],
      ["h", 5, [3]],
      ["ic", 6, [2, 1], [3]],
      ["ic", 7, [0], [6]],
    ],
  },
};
Object.assign(mdEditor, {
  __deps__: autoParser1674486654837_0.mdEditor.deps,
  __names__: autoParser1674486654837_0.mdEditor.names,
  __name__: "mdEditor",
  __namespace__: "tarat-markdown-editor",
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});

/**. auto generated by tarat */
// location at:/Users/yunge/Documents/tarat/packages/example/markdown-editor/dist/server/drivers/cjs/mdEditor.js
const autoParser1674486657044_4 = {
  mdEditor: {
    names: [
      [0, "currentId"],
      [1, "inputMD"],
      [2, "inputTitle"],
      [3, "currentPost"],
      [4, "markdownTitle"],
      [5, "postedMD"],
      [6, "writeCurrentMD"],
      [7, "save"],
    ],
    deps: [
      ["h", 3, [0]],
      ["h", 4, [3]],
      ["h", 5, [3]],
      ["ic", 6, [2, 1], [3]],
      ["ic", 7, [0], [6]],
    ],
  },
};
Object.assign(mdEditor, {
  __deps__: autoParser1674486657044_4.mdEditor.deps,
  __names__: autoParser1674486657044_4.mdEditor.names,
  __name__: "mdEditor",
  __namespace__: "tarat-markdown-editor",
});
/** auto generated by tarat .*/
