// dist/drivers/mdList.js
import { inputComputeInServer, model, state, writePrisma } from "tarat/core";

// models/indexes.json
var indexes_default = {
  markdown: "markdown"
};

// dist/drivers/mdList.js
function mdList(q = {}) {
  const list = model(indexes_default.markdown, () => ({}));
  const title = state("");
  const writeList = writePrisma(list, () => ({
    title: title()
  }));
  const addMD = inputComputeInServer(function* () {
    yield writeList.create();
    title(() => "");
  });
  return {
    title,
    addMD,
    list
  };
}
var autoParser1674486656413_1 = {
  mdList: {
    names: [
      [0, "list"],
      [1, "title"],
      [2, "writeList"],
      [3, "addMD"]
    ],
    deps: [
      ["ic", 2, [1], [0]],
      ["ic", 3, [], [2, 1]]
    ]
  }
};
Object.assign(mdList, {
  __deps__: autoParser1674486656413_1.mdList.deps,
  __names__: autoParser1674486656413_1.mdList.names,
  __name__: "mdList",
  __namespace__: "tarat-markdown-editor"
});
export {
  mdList as default
};
